﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MockupBall : MonoBehaviour
{
    public MockupManager.BallState occState;

    public List<MockupManager.BallState> frameStates;


    void Awake(){
        frameStates=new List<MockupManager.BallState>();
    }

    void Update(){
        checkFrameStates();
        frameStates.Clear();
    }

    private void addFrameState(MockupManager.BallState state_){
        if(frameStates.Contains(state_)){
            return;
        }
        frameStates.Add(state_);
    }

    private void checkFrameStates(){
        MockupManager.BallState bs_=MockupManager.BallState.Rough;
        if(frameStates.Count==0){return;}
        foreach(MockupManager.BallState s_ in frameStates){
            switch(s_){
                case MockupManager.BallState.Green:
                if(bs_==MockupManager.BallState.Sand){break;}

                bs_=s_;
                break;
                case MockupManager.BallState.Fairway:
                if(bs_==MockupManager.BallState.Green){break;}
                if(bs_==MockupManager.BallState.Sand){break;}
                if(bs_==MockupManager.BallState.Water){break;}
                bs_=s_;
                break;
                case MockupManager.BallState.Rough:
                if(bs_==MockupManager.BallState.Green){break;}
                if(bs_==MockupManager.BallState.Sand){break;}
                if(bs_==MockupManager.BallState.Water){break;}
                if(bs_==MockupManager.BallState.Fairway){break;}
                bs_=s_;
                break;
                case MockupManager.BallState.Sand:

                bs_=s_;

                break;
                case MockupManager.BallState.Water:
                if(bs_==MockupManager.BallState.Green){break;}

                bs_=s_;

                break;
            }

        }

        

        occState=bs_;
    }
    
    void OnTriggerStay2D(Collider2D other_){
        string tag_=other_.gameObject.tag;



        if(tag_=="Fairway"){
            addFrameState(MockupManager.BallState.Fairway);
        }else if(tag_=="Green"){
            addFrameState(MockupManager.BallState.Green);
        }else if(tag_=="Water"){
            addFrameState(MockupManager.BallState.Water);
        }else if(tag_=="Sand"){
            addFrameState(MockupManager.BallState.Sand);
        }else if(tag_=="Rough"){
            addFrameState(MockupManager.BallState.Rough);
        }

    }
}
