﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MockupManager : MonoBehaviour
{
    public static MockupManager Instance;

    public MockupBall mockupBall;

    public BallState ballState;
    
    private Vector3 mockupPos;


    [System.Serializable]
    public enum BallState{
        Airborne,
        Fairway,
        Green,
        Sand,
        Water,
        Rough
    }

    void Awake()
    {
        Instance=this;

        mockupPos=new Vector3();
    }

    // Update is called once per frame
    void Update()
    {
        updateMockupBall();
    }


    public void updateMockupBall(){
        Vector3 ballPos_=GameManager.Instance.ball.ball.transform.position;
        mockupPos.Set(ballPos_.x,ballPos_.z,0);

        mockupBall.transform.position=mockupPos+Vector3.zero;

        if(ballPos_.y>.5f){
            ballState=BallState.Airborne;
            return;
        }

        if(ballState==BallState.Airborne){
            //landed on ground/water, but what ground?
            switch(mockupBall.occState){
                case BallState.Sand:
                GameManager.Instance.ballHitSand.play();
                break;
                case BallState.Water:
                //we'll play this when they revert shot just in case...
                break;
                default:
                GameManager.Instance.ballHitGround.play();
                break;
            }

        }

        ballState=mockupBall.occState;

    }
}
